%global scl scorep2
%{?scl:%scl_package scorep}
%{!?scl:%global pkg_name %{name}}
%define _enable_debug_packages 0

Name:           %{?scl_prefix}scorep
Version:        2.0
Release:        1.20151218%{?dist}
Summary:        Scalable Performance Measurement Infrastructure for Parallel Codes

License:        BSD
URL:            http://periscope.in.tum.de/
Source0:        http://periscope.in.tum.de/releases/latest/tar/Score-P.tar.bz2#/Score-P-for-PTF.tar.bz2
# Fix getaddrinfo() feature test
Patch0:         scorep-getaddrinfo.patch
BuildRequires:  gcc-gfortran
BuildRequires:  bison
BuildRequires:  flex
BuildRequires:  binutils-devel
BuildRequires:  chrpath
BuildRequires:  cube-devel >= 4.3
BuildRequires:  papi-devel
BuildRequires:  scl-utils-build
Requires:       %{?scl_prefix}%{pkg_name}-libs%{?_isa} = %{version}-%{release}
Requires:       binutils-devel%{?_isa}
Requires:       cube-devel%{?_isa} >= 4.3
Requires:       papi-devel%{?_isa}
%{?scl:Requires: %scl_runtime}


%{!?with_mpich:%global with_mpich 1}
%{!?with_openmpi:%global with_openmpi 1}
%ifarch s390 s390x
# No openmpi on s390(x)
%global with_openmpi 0
%endif
# No mpich on EL6 ppc64
%ifarch ppc64
%if 0%{?rhel} && 0%{?rhel} <= 6
%global with_mpich 0
%endif
%endif

%if %{with_mpich}
%global mpi_list mpich
%endif
%if %{with_openmpi}
%global mpi_list %{?mpi_list} openmpi
%endif

%description
The Score-P (Scalable Performance Measurement Infrastructure for
Parallel Codes) measurement infrastructure is a highly scalable and
easy-to-use tool suite for profiling, event trace recording, and
online analysis of HPC applications.

This is an interim special version to support PTF.


%package        doc
Summary:        Documentation for %{pkg_name}
BuildArch:      noarch

%description    doc
The %{pkg_name}-doc package contains documentation for %{pkg_name}


%package libs
Summary:        Score-P runtime libraries

%description libs
Score-P runtime libraries.

This is an interim special version to support PTF.

%if %{with_mpich}
%package mpich
Summary:        Scalable Performance Measurement Infrastructure for Parallel Codes for mpich
BuildRequires:  mpich-devel
Requires:       %{?scl_prefix}%{pkg_name}-mpich-libs%{?_isa} = %{version}-%{release}
Requires:       cube-devel%{?_isa} >= 4.3
Requires:       %{?scl_prefix}otf2-devel%{?_isa} >= 1.5
Requires:       papi-devel%{?_isa}

%description mpich
The Score-P (Scalable Performance Measurement Infrastructure for
Parallel Codes) measurement infrastructure is a highly scalable and
easy-to-use tool suite for profiling, event trace recording, and
online analysis of HPC applications.

This package was compiled with mpich.


%package mpich-libs
Summary:        Score-P mpich runtime libraries

%description mpich-libs
Score-P mpich runtime libraries.

This is an interim special version to support PTF.
%endif


%if %{with_openmpi}
%package openmpi
Summary:        Scalable Performance Measurement Infrastructure for Parallel Codes for openmpi
BuildRequires:  openmpi-devel
Requires:       %{?scl_prefix}%{pkg_name}-openmpi-libs%{?_isa} = %{version}-%{release}
Requires:       cube-devel%{?_isa} >= 4.3
Requires:       papi-devel%{?_isa}

%description openmpi
The Score-P (Scalable Performance Measurement Infrastructure for
Parallel Codes) measurement infrastructure is a highly scalable and
easy-to-use tool suite for profiling, event trace recording, and
online analysis of HPC applications.

This package was compiled with openmpi.

This is an interim special version to support PTF.

%package openmpi-libs
Summary:        Score-P openmpi runtime libraries

%description openmpi-libs
Score-P openmpi runtime libraries.

This is an interim special version to support PTF.
%endif


%prep
%setup -q -n Score-P
#%patch0 -p1 -b .getaddrinfo
find -name .svn | xargs rm -rf
for d in $(find -name build-config); do touch $d/{REVISION_COMMON,REVISION}; done

%build
%global _configure ../configure
%global configure_opts --enable-shared --disable-static --disable-silent-rules --without-otf2 --without-opari2

cp /usr/lib/rpm/redhat/config.{sub,guess} build-config/

# Build serial version
mkdir serial
cd serial
%configure %{configure_opts} --without-mpi --without-shmem
make %{?_smp_mflags}
cd -

# Build MPI versions
for mpi in %{mpi_list}
do
  mkdir $mpi
  cd $mpi
%if 0%{?el6}
  module load $mpi-%{_arch}
%else
  module load mpi/$mpi-%{_arch}
%endif
  ln -s ../configure .
  %configure %{configure_opts} \
    --libdir=%{_libdir}/$mpi/lib \
    --bindir=%{_libdir}/$mpi/bin \
    --sbindir=%{_libdir}/$mpi/sbin \
    --includedir=%{_includedir}/$mpi-%{_arch} \
    --mandir=%{_libdir}/$mpi/share/man
  make %{?_smp_mflags}
  module purge
  cd -
done


%install
%make_install -C serial
# Install doc
cp -p AUTHORS ChangeLog README THANKS \
      %{buildroot}%{_defaultdocdir}/scorep/
# Strip rpath
chrpath -d %{buildroot}%{_libdir}/*.so.*

for mpi in %{mpi_list}
do
%if 0%{?el6}
  module load $mpi-%{_arch}
%else
  module load mpi/$mpi-%{_arch}
%endif
  %make_install -C $mpi
  module purge
done
find %{buildroot} -name '*.la' -exec rm -f {} ';'


%post libs -p /sbin/ldconfig

%postun libs -p /sbin/ldconfig


%{!?_licensedir:%global license %%doc}
%files
%exclude %_usrsrc
%exclude /usr/lib/debug
%license COPYING
%dir %{_defaultdocdir}/scorep
%{_defaultdocdir}/scorep/AUTHORS
%{_defaultdocdir}/scorep/ChangeLog
%{_defaultdocdir}/scorep/README
%{_defaultdocdir}/scorep/THANKS
%{_bindir}/*
%{_datadir}/scorep/
%{_datadir}/opari2/
%{_datadir}/otf2/
%{_includedir}/scorep/
%{_includedir}/opari2/
%{_includedir}/otf2/
%{_libexecdir}/pomp2-parse-init-regions.awk

%files doc
%doc %{_defaultdocdir}

%files libs
%license COPYING
%{_libdir}/*.so*

%if %{with_mpich}
%files mpich
%license COPYING
%doc AUTHORS ChangeLog README THANKS
%{_libdir}/mpich/bin/*
%{_includedir}/mpich-%{_arch}/*

%files mpich-libs
%{_libdir}/mpich/lib/*.so*
%endif

%if %{with_openmpi}
%files openmpi
%license COPYING
%doc AUTHORS ChangeLog README THANKS
%{_libdir}/openmpi/bin/*
%{_includedir}/openmpi-%{_arch}/*

%files openmpi-libs
%{_libdir}/openmpi/lib/*.so*
%endif

%changelog
* Mon Jan 11 2016 Dave Love <loveshack@fedoraproject.org> - 2.0-1.20151218
- Initial SCL version, adapted from vanilla scorep
